<?php
class choferActions extends wtActions
{
    public function executeIndex()
    {
    }
    
    public function executeList()
    {
        LayoutTemplate::getInstance()->setUseBootstrap();
    	$this->block = $this->getRequestParameter( 'block' );
        
        $this->Titulo = "Chofer";
        $this->NomMod = ParameterWR::getInstance()->getModule();
    }
    
    public function executeGrid()
    {
        $block = $this->getRequestParameter( 'block' );
        $page  = $this->getRequestParameter( 'page' );
        
        //*set_header_utf8();
        ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
        $o_GridAction = new GridAction();
        $o_GridAction->setClassFind( new TR_ChoferFN() );
        
        $o_GridAction->addConditionFilter( "Descripcion", TR_ChoferFN::ChoferNombre, "LIKE", "%%s%" );
        
        $o_GridAction->addOrder( "Descripcion", TR_ChoferFN::ChoferNombre );
        
        $o_GridAction->addOrderDefault( TR_ChoferFN::ChoferNombre , true );
        
        $o_GridAction->addRowsToShow( "IdChofer", "ChoferDocumento", "ChoferNombre", "FechaCreacion", "EstadoDesc" );
              
        $o_GridAction->setNumberRecordsShow( 15 );
        
        $o_GridAction->initialize();
        ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
        $a_ResultJson['page']    = $o_GridAction->getPage();
        $a_ResultJson['total']   = $o_GridAction->getTotalPage();
        $a_ResultJson['records'] = $o_GridAction->getTotalRecords();
        $a_ResultJson['rows']    = $o_GridAction->getResultArray();
        //pr( $a_ResultJson );
        echo json_encode( $a_ResultJson );

        return ViewResponse::NONE;   
    }
    
    public function executeAddedit()
    {
        LayoutTemplate::getInstance()->setUseBootstrap();
        $this->block    = $this->getRequestParameter( 'block' );
        $this->Id       = $this->getRequestParameter( 'Id' );
        $this->TipoProc = $this->getRequestParameter( 'TipoProc' );
        
        $this->Titulo = "Nuevo Chofer";
        $this->NomMod = ParameterWR::getInstance()->getModule();
        
        /************/
        
        $o_DefaultBN = new TR_ChoferFN();
        $o_DefaultBN->setEstado( 'A' );
        $this->o_DefaultBN = $o_DefaultBN;
        
        /*************/
        //$this->o_MST_UnidadMastBN = new MST_UnidadMastBN();
        if( $this->TipoProc == "upd" )
        {
            $this->Titulo = "Editar Chofer";
            $o_DefaultFN = new TR_ChoferFN();
            $this->o_DefaultBN = $o_DefaultFN->selectByPK( $this->Id );
        }
    }
    
    public function executeSaveAddEdit()
    {
        $block    = $this->getRequestParameter( 'block' );
        $Id       = $this->getRequestParameter( 'Id' );
        $TipoProc = $this->getRequestParameter( 'TipoProc' );
        $TypeSub  = $this->getRequestParameter( 'TypeSub' );
        
        $IdCompania = myUser::getUser()->getIdBusiness();
        $IdSucursal = myUser::getUser()->getIdSucursal();
        
        $ChoferDocumento = $this->getRequestParameter( 'ChoferDocumento' );
        $ChoferNombre    = $this->getRequestParameter( 'ChoferNombre' );
        $ChoferApellidoP    = $this->getRequestParameter( 'ChoferApellidoP' );
        $ChoferApellidoM    = $this->getRequestParameter( 'ChoferApellidoM' );
        $ChoferTelefono  = $this->getRequestParameter( 'ChoferTelefono' );
        $ChoferUbigeo  = $this->getRequestParameter( 'ChoferUbigeo' );
        $ChoferLicencia  = $this->getRequestParameter( 'ChoferLicencia' );
        $ChoferCategoria  = $this->getRequestParameter( 'ChoferCategoria' );
        $ChoferDireccion  = $this->getRequestParameter( 'ChoferDireccion' );
        $ChoferAyudante  = $this->getRequestParameter( 'ChoferAyudante' );
        $Estado          = $this->getRequestParameter( 'Estado' );
        
        $o_Con = Conexion::getConexion();
        try 
        {
            $o_Con->begin();
            
            $o_DefaultDP = new TR_ChoferDP();
            $o_DefaultDP->setChoferDocumento( $ChoferDocumento );
            $o_DefaultDP->setChoferNombre( $ChoferNombre );
            $o_DefaultDP->setChoferTelefono( $ChoferTelefono );
            $o_DefaultDP->setChoferLicencia( $ChoferLicencia );
            $o_DefaultDP->setChoferAyudante( $ChoferAyudante );
            $o_DefaultDP->setChoferApellidoP( $ChoferApellidoP );
            $o_DefaultDP->setChoferApellidoM( $ChoferApellidoM );
            $o_DefaultDP->setChoferCategoria( $ChoferCategoria );
            $o_DefaultDP->setChoferDireccion( $ChoferDireccion );
            $o_DefaultDP->setChoferUbigeo( $ChoferUbigeo );
            $o_DefaultDP->setEstado( $Estado );
            if( $TipoProc == "nvo" )
            {
                //NUEVO
                $IdReg = TR_ChoferFN::recuperarId();
                
                $o_DefaultDP->setIdCompania( $IdCompania );
                $o_DefaultDP->setIdSucursal( $IdSucursal );
                $o_DefaultDP->setIdChofer( $IdReg );
                $o_DefaultDP->setFechaCreacion( date( "Y-m-d H:i:s" ) );
                $o_DefaultDP->setUsuarioCreacion( myUser::getUser()->getUserId() );
                $o_DefaultDP->setFechaModificacion( date( "Y-m-d H:i:s" ) );
                $o_DefaultDP->setUsuarioModificacion( myUser::getUser()->getUserId() );
                $b_Result = $o_DefaultDP->save();
                $Id = $IdReg;
            }
            else 
            {
                //UPDATE
                $o_DefaultDP->setIdChofer( ( int ) $Id );
                $o_DefaultDP->setFechaModificacion( date( "Y-m-d H:i:s" ) );
                $o_DefaultDP->setUsuarioModificacion( myUser::getUser()->getUserId() );
                $b_Result = $o_DefaultDP->update();
            }
            $a_Rs['type_sub'] = $TypeSub;
            $a_Rs['error']    = false;
            $a_Rs['id']       = $Id;
            
            $o_Con->commit();
        }
        catch ( Exception $o_Exception )
        {
            $o_Con->rollback();
            
            $a_Rs['error']         = true;
            $a_Rs['mensaje_error'] = $o_Exception->getMessage();
        }
        echo json_encode( $a_Rs );
        return ViewResponse::NONE;
    }
    
    public function executeAudi()
    {
        $block        = $this->getRequestParameter( 'block' );
        $Id           = $this->getRequestParameter( 'Id' );
        
        $this->Topico = "Chofer";
        
        $o_DefaultFN = new TR_ChoferFN();
        $this->o_ObjectBN = $o_DefaultFN->selectByPK( $Id );
    }
    
    public function executeViewdel()
    {
        $this->block    = $this->getRequestParameter( 'block' );
        $this->Id       = $this->getRequestParameter( 'Id' );
        $this->TipoProc = $this->getRequestParameter( 'TipoProc' );
        
        $this->NomMod = ParameterWR::getInstance()->getModule();
        
        $o_DefaultFN = new TR_ChoferFN();
        $this->o_DefaultBN = $o_DefaultFN->selectByPK( $this->Id );
    }
    
    public function executeDeleteRow()
    {
        $block    = $this->getRequestParameter( 'block' );
        $Id       = $this->getRequestParameter( 'Id' );
        $TipoProc = $this->getRequestParameter( 'TipoProc' );
        try 
        {
            $o_DefaultDP = new TR_ChoferDP();
            $o_DefaultDP->setIdChofer( ( int ) $Id );
            $o_DefaultDP->setEstado( "I" );
            $o_DefaultDP->setUsuarioModificacion( myUser::getUser()->getUserId() );
            $o_DefaultDP->setFechaModificacion( date( "Y-m-d H:i:s" ) );
            $o_DefaultDP->update();
            //$o_DefaultDP->delete();

            $a_Rs['error']   = false;
            $a_Rs['id']      = $Id;
        }
        catch ( Exception $o_Exception )
        {
            $a_Rs['error']   = true;
            $a_Rs['mensaje_error_ex'] = $o_Exception->getMessage();
            $a_Rs['mensaje_error'] = "No se pudo eliminar el registro.";
        }
        echo json_encode( $a_Rs );
        return ViewResponse::NONE;
    }
}